#!/bin/bash

version=$(python3 -c "import sys; sys.path.insert(0, './usr/lib/python3/dist-packages/');from webengine.gtk3 import version;print(version)")


if [ -d unpack ]; then
  sudo rm -rf unpack
fi

find usr -type d -name __pycache__ | xargs rm -rf

mkdir -p unpack/DEBIAN

cp debian/control unpack/DEBIAN/
cp -r usr unpack/

cd unpack
find usr -type f | xargs md5sum > DEBIAN/md5sums

_size=$(du -d 0 usr | cut -f1)
sed -i "s/{{size}}/${_size}/" DEBIAN/control
sed -i "s/{{version}}/${version}/" DEBIAN/control

cd ..
sudo chown -R root:root unpack/
dpkg-deb -b unpack/ "python3-webengine-gtk3-${version}.deb"

sudo rm -rf unpack